<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;regex-syntax-0.6.25&#x2F;src&#x2F;hir&#x2F;visitor.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>visitor.rs - source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../storage.js"></script><script src="../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../regex_syntax/index.html'><div class='logo-container rust-logo'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::hir</span>::{<span class="self">self</span>, <span class="ident">Hir</span>, <span class="ident">HirKind</span>};

<span class="doccomment">/// A trait for visiting the high-level IR (HIR) in depth first order.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The principle aim of this trait is to enable callers to perform case</span>
<span class="doccomment">/// analysis on a high-level intermediate representation of a regular</span>
<span class="doccomment">/// expression without necessarily using recursion. In particular, this permits</span>
<span class="doccomment">/// callers to do case analysis with constant stack usage, which can be</span>
<span class="doccomment">/// important since the size of an HIR may be proportional to end user input.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Typical usage of this trait involves providing an implementation and then</span>
<span class="doccomment">/// running it using the [`visit`](fn.visit.html) function.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Visitor</span> {
    <span class="doccomment">/// The result of visiting an HIR.</span>
    <span class="kw">type</span> <span class="ident">Output</span>;
    <span class="doccomment">/// An error that visiting an HIR might return.</span>
    <span class="kw">type</span> <span class="prelude-val">Err</span>;

    <span class="doccomment">/// All implementors of `Visitor` must provide a `finish` method, which</span>
    <span class="doccomment">/// yields the result of visiting the HIR or an error.</span>
    <span class="kw">fn</span> <span class="ident">finish</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident"><span class="self">Self</span>::Output</span>, <span class="ident"><span class="self">Self</span>::Err</span><span class="op">&gt;</span>;

    <span class="doccomment">/// This method is called before beginning traversal of the HIR.</span>
    <span class="kw">fn</span> <span class="ident">start</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) {}

    <span class="doccomment">/// This method is called on an `Hir` before descending into child `Hir`</span>
    <span class="doccomment">/// nodes.</span>
    <span class="kw">fn</span> <span class="ident">visit_pre</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">_hir</span>: <span class="kw-2">&amp;</span><span class="ident">Hir</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident"><span class="self">Self</span>::Err</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(())
    }

    <span class="doccomment">/// This method is called on an `Hir` after descending all of its child</span>
    <span class="doccomment">/// `Hir` nodes.</span>
    <span class="kw">fn</span> <span class="ident">visit_post</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">_hir</span>: <span class="kw-2">&amp;</span><span class="ident">Hir</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident"><span class="self">Self</span>::Err</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(())
    }

    <span class="doccomment">/// This method is called between child nodes of an alternation.</span>
    <span class="kw">fn</span> <span class="ident">visit_alternation_in</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident"><span class="self">Self</span>::Err</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="doccomment">/// Executes an implementation of `Visitor` in constant stack space.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function will visit every node in the given `Hir` while calling</span>
<span class="doccomment">/// appropriate methods provided by the</span>
<span class="doccomment">/// [`Visitor`](trait.Visitor.html) trait.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The primary use case for this method is when one wants to perform case</span>
<span class="doccomment">/// analysis over an `Hir` without using a stack size proportional to the depth</span>
<span class="doccomment">/// of the `Hir`. Namely, this method will instead use constant stack space,</span>
<span class="doccomment">/// but will use heap space proportional to the size of the `Hir`. This may be</span>
<span class="doccomment">/// desirable in cases where the size of `Hir` is proportional to end user</span>
<span class="doccomment">/// input.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// If the visitor returns an error at any point, then visiting is stopped and</span>
<span class="doccomment">/// the error is returned.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">visit</span><span class="op">&lt;</span><span class="ident">V</span>: <span class="ident">Visitor</span><span class="op">&gt;</span>(<span class="ident">hir</span>: <span class="kw-2">&amp;</span><span class="ident">Hir</span>, <span class="ident">visitor</span>: <span class="ident">V</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">V::Output</span>, <span class="ident">V::Err</span><span class="op">&gt;</span> {
    <span class="ident">HeapVisitor::new</span>().<span class="ident">visit</span>(<span class="ident">hir</span>, <span class="ident">visitor</span>)
}

<span class="doccomment">/// HeapVisitor visits every item in an `Hir` recursively using constant stack</span>
<span class="doccomment">/// size and a heap size proportional to the size of the `Hir`.</span>
<span class="kw">struct</span> <span class="ident">HeapVisitor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// A stack of `Hir` nodes. This is roughly analogous to the call stack</span>
    <span class="doccomment">/// used in a typical recursive visitor.</span>
    <span class="ident">stack</span>: <span class="ident">Vec</span><span class="op">&lt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Hir</span>, <span class="ident">Frame</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>)<span class="op">&gt;</span>,
}

<span class="doccomment">/// Represents a single stack frame while performing structural induction over</span>
<span class="doccomment">/// an `Hir`.</span>
<span class="kw">enum</span> <span class="ident">Frame</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// A stack frame allocated just before descending into a repetition</span>
    <span class="doccomment">/// operator&#39;s child node.</span>
    <span class="ident">Repetition</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">hir::Repetition</span>),
    <span class="doccomment">/// A stack frame allocated just before descending into a group&#39;s child</span>
    <span class="doccomment">/// node.</span>
    <span class="ident">Group</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">hir::Group</span>),
    <span class="doccomment">/// The stack frame used while visiting every child node of a concatenation</span>
    <span class="doccomment">/// of expressions.</span>
    <span class="ident">Concat</span> {
        <span class="doccomment">/// The child node we are currently visiting.</span>
        <span class="ident">head</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Hir</span>,
        <span class="doccomment">/// The remaining child nodes to visit (which may be empty).</span>
        <span class="ident">tail</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">Hir</span>],
    },
    <span class="doccomment">/// The stack frame used while visiting every child node of an alternation</span>
    <span class="doccomment">/// of expressions.</span>
    <span class="ident">Alternation</span> {
        <span class="doccomment">/// The child node we are currently visiting.</span>
        <span class="ident">head</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Hir</span>,
        <span class="doccomment">/// The remaining child nodes to visit (which may be empty).</span>
        <span class="ident">tail</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">Hir</span>],
    },
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">HeapVisitor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">HeapVisitor</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="ident">HeapVisitor</span> { <span class="ident">stack</span>: <span class="macro">vec!</span>[] }
    }

    <span class="kw">fn</span> <span class="ident">visit</span><span class="op">&lt;</span><span class="ident">V</span>: <span class="ident">Visitor</span><span class="op">&gt;</span>(
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>,
        <span class="kw-2">mut</span> <span class="ident">hir</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Hir</span>,
        <span class="kw-2">mut</span> <span class="ident">visitor</span>: <span class="ident">V</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">V::Output</span>, <span class="ident">V::Err</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">clear</span>();

        <span class="ident">visitor</span>.<span class="ident">start</span>();
        <span class="kw">loop</span> {
            <span class="ident">visitor</span>.<span class="ident">visit_pre</span>(<span class="ident">hir</span>)<span class="question-mark">?</span>;
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">x</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">induct</span>(<span class="ident">hir</span>) {
                <span class="kw">let</span> <span class="ident">child</span> <span class="op">=</span> <span class="ident">x</span>.<span class="ident">child</span>();
                <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">push</span>((<span class="ident">hir</span>, <span class="ident">x</span>));
                <span class="ident">hir</span> <span class="op">=</span> <span class="ident">child</span>;
                <span class="kw">continue</span>;
            }
            <span class="comment">// No induction means we have a base case, so we can post visit</span>
            <span class="comment">// it now.</span>
            <span class="ident">visitor</span>.<span class="ident">visit_post</span>(<span class="ident">hir</span>)<span class="question-mark">?</span>;

            <span class="comment">// At this point, we now try to pop our call stack until it is</span>
            <span class="comment">// either empty or we hit another inductive case.</span>
            <span class="kw">loop</span> {
                <span class="kw">let</span> (<span class="ident">post_hir</span>, <span class="ident">frame</span>) <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">pop</span>() {
                    <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">return</span> <span class="ident">visitor</span>.<span class="ident">finish</span>(),
                    <span class="prelude-val">Some</span>((<span class="ident">post_hir</span>, <span class="ident">frame</span>)) <span class="op">=</span><span class="op">&gt;</span> (<span class="ident">post_hir</span>, <span class="ident">frame</span>),
                };
                <span class="comment">// If this is a concat/alternate, then we might have additional</span>
                <span class="comment">// inductive steps to process.</span>
                <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">x</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">pop</span>(<span class="ident">frame</span>) {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="ident">Frame::Alternation</span> { .. } <span class="op">=</span> <span class="ident">x</span> {
                        <span class="ident">visitor</span>.<span class="ident">visit_alternation_in</span>()<span class="question-mark">?</span>;
                    }
                    <span class="ident">hir</span> <span class="op">=</span> <span class="ident">x</span>.<span class="ident">child</span>();
                    <span class="self">self</span>.<span class="ident">stack</span>.<span class="ident">push</span>((<span class="ident">post_hir</span>, <span class="ident">x</span>));
                    <span class="kw">break</span>;
                }
                <span class="comment">// Otherwise, we&#39;ve finished visiting all the child nodes for</span>
                <span class="comment">// this HIR, so we can post visit it now.</span>
                <span class="ident">visitor</span>.<span class="ident">visit_post</span>(<span class="ident">post_hir</span>)<span class="question-mark">?</span>;
            }
        }
    }

    <span class="doccomment">/// Build a stack frame for the given HIR if one is needed (which occurs if</span>
    <span class="doccomment">/// and only if there are child nodes in the HIR). Otherwise, return None.</span>
    <span class="kw">fn</span> <span class="ident">induct</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">hir</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Hir</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Frame</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="ident">hir</span>.<span class="ident">kind</span>() {
            <span class="ident">HirKind::Repetition</span>(<span class="kw-2">ref</span> <span class="ident">x</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="ident">Frame::Repetition</span>(<span class="ident">x</span>)),
            <span class="ident">HirKind::Group</span>(<span class="kw-2">ref</span> <span class="ident">x</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="ident">Frame::Group</span>(<span class="ident">x</span>)),
            <span class="ident">HirKind::Concat</span>(<span class="kw-2">ref</span> <span class="ident">x</span>) <span class="kw">if</span> <span class="ident">x</span>.<span class="ident">is_empty</span>() <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
            <span class="ident">HirKind::Concat</span>(<span class="kw-2">ref</span> <span class="ident">x</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="prelude-val">Some</span>(<span class="ident">Frame::Concat</span> { <span class="ident">head</span>: <span class="kw-2">&amp;</span><span class="ident">x</span>[<span class="number">0</span>], <span class="ident">tail</span>: <span class="kw-2">&amp;</span><span class="ident">x</span>[<span class="number">1</span>..] })
            }
            <span class="ident">HirKind::Alternation</span>(<span class="kw-2">ref</span> <span class="ident">x</span>) <span class="kw">if</span> <span class="ident">x</span>.<span class="ident">is_empty</span>() <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
            <span class="ident">HirKind::Alternation</span>(<span class="kw-2">ref</span> <span class="ident">x</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="prelude-val">Some</span>(<span class="ident">Frame::Alternation</span> { <span class="ident">head</span>: <span class="kw-2">&amp;</span><span class="ident">x</span>[<span class="number">0</span>], <span class="ident">tail</span>: <span class="kw-2">&amp;</span><span class="ident">x</span>[<span class="number">1</span>..] })
            }
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }

    <span class="doccomment">/// Pops the given frame. If the frame has an additional inductive step,</span>
    <span class="doccomment">/// then return it, otherwise return `None`.</span>
    <span class="kw">fn</span> <span class="ident">pop</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">induct</span>: <span class="ident">Frame</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Frame</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="ident">induct</span> {
            <span class="ident">Frame::Repetition</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
            <span class="ident">Frame::Group</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
            <span class="ident">Frame::Concat</span> { <span class="ident">tail</span>, .. } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">if</span> <span class="ident">tail</span>.<span class="ident">is_empty</span>() {
                    <span class="prelude-val">None</span>
                } <span class="kw">else</span> {
                    <span class="prelude-val">Some</span>(<span class="ident">Frame::Concat</span> { <span class="ident">head</span>: <span class="kw-2">&amp;</span><span class="ident">tail</span>[<span class="number">0</span>], <span class="ident">tail</span>: <span class="kw-2">&amp;</span><span class="ident">tail</span>[<span class="number">1</span>..] })
                }
            }
            <span class="ident">Frame::Alternation</span> { <span class="ident">tail</span>, .. } <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">if</span> <span class="ident">tail</span>.<span class="ident">is_empty</span>() {
                    <span class="prelude-val">None</span>
                } <span class="kw">else</span> {
                    <span class="prelude-val">Some</span>(<span class="ident">Frame::Alternation</span> {
                        <span class="ident">head</span>: <span class="kw-2">&amp;</span><span class="ident">tail</span>[<span class="number">0</span>],
                        <span class="ident">tail</span>: <span class="kw-2">&amp;</span><span class="ident">tail</span>[<span class="number">1</span>..],
                    })
                }
            }
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Frame</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Perform the next inductive step on this frame and return the next</span>
    <span class="doccomment">/// child HIR node to visit.</span>
    <span class="kw">fn</span> <span class="ident">child</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Hir</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Frame::Repetition</span>(<span class="ident">rep</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">rep</span>.<span class="ident">hir</span>,
            <span class="ident">Frame::Group</span>(<span class="ident">group</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">group</span>.<span class="ident">hir</span>,
            <span class="ident">Frame::Concat</span> { <span class="ident">head</span>, .. } <span class="op">=</span><span class="op">&gt;</span> <span class="ident">head</span>,
            <span class="ident">Frame::Alternation</span> { <span class="ident">head</span>, .. } <span class="op">=</span><span class="op">&gt;</span> <span class="ident">head</span>,
        }
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="regex_syntax" data-search-index-js="../../../search-index.js" data-search-js="../../../search.js"></div>
    <script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script>
</body></html>